package com.jorge.test.hello.security;

import java.io.IOException;

import javax.security.auth.callback.Callback;
import javax.security.auth.callback.CallbackHandler;
import javax.security.auth.callback.UnsupportedCallbackException;

import org.apache.commons.lang.StringUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.ws.security.WSPasswordCallback;

public class ServerPasswordCallback implements CallbackHandler {

    private static final Log log = LogFactory.getLog(ServerPasswordCallback.class);

    /**
     * {@inheritDoc}
     */
    public void handle(final Callback[] callbacks) throws IOException, UnsupportedCallbackException {
        for (Callback callback : callbacks) {
            if (callback instanceof WSPasswordCallback) {
                WSPasswordCallback pc = (WSPasswordCallback) callback;
                if (log.isDebugEnabled()) {
                    log.debug("authentication with username '" + pc.getIdentifier() + "' and password '" + pc.getPassword() + "'");
                }
                if (StringUtils.equals(pc.getIdentifier(), "11")) {
                    pc.setPassword("p");
                    return;
                }
                throw new SecurityException("username " + pc.getIdentifier() + " is not recognized; use username 11");
            } else {
                throw new UnsupportedCallbackException(callback, "callback of type " + callback.getClass().getSimpleName() + " is not supported");
            }
        }
    }

}
